<?php

// Do not allow direct access to the file.
if( ! defined( 'ABSPATH' ) ) exit;

/*
 Setting for Adyen Gateway.
*/
return array(
    'enabled' => array(
        'title'			=> __( 'Enable', 'adyen' ),
        'type'			=> 'checkbox',
        'label'			=> __( 'Enable Adyen Payment Gateway.', 'adyen' ),
        'default'		=> 'no'
    ),
    'title' => array(
        'title'			=> __( 'Title:', 'adyen' ),
        'type'			=> 'text',
        'description' 	=> __( 'This controls the title which the user sees during checkout.', 'adyen' ),
        'desc_tip'      => true,
        'default'		=> __( 'Adyen', 'adyen' )
    ),
    'description' => array(
        'title'			=> __( 'Description:', 'adyen' ),
        'type'			=> 'textarea',
        'description'	=> __( 'This controls the description which the user sees during checkout.', 'adyen' ),
        'desc_tip'      => true,
        'default'		=> __( 'Adyen is a leading provider of omni-channel payment solutions with over 250 payment methods and 187 transaction currencies.', 'adyen' )
    ),
    'merchant_account' => array(
        'title'			=> __( 'Merchant Account', 'adyen' ),
        'type'			=> 'text',
        'description'	=> __( 'Please enter your Adyen merchant account; this is needed in order to take payment.' ),
        'desc_tip'      => true
    ),
    'hmac_key' => array(
        'title'			=> __( 'HMAC Key', 'adyen' ),
        'type'			=> 'text',
        'description'	=>  __( 'Enter your Adyen generated HMAC key (Live Platform).', 'adyen' ),
        'desc_tip'      => true
    ),
    'skin_code' => array(
        'title'			=> __( 'Skin Code', 'adyen' ),
        'type'			=> 'text',
        'description'	=>  __( 'Enter your Adyen generated skin code.', 'adyen' ),
        'desc_tip'      => true
    ),
    'result_notification_url' => array(
        'title'         => __( 'Result / Notification URL', 'adyen' ),
        'type'          => 'text',
        'description'   => __( 'Copy result / notification url for Adyen result / notifications inputs.', 'adyen' ),
        'desc_tip'      => true,
        'disabled'      => true,
        'default'       => esc_url( WC()->api_request_url( 'WC_Gateway_Adyen' ) )
    ),
    'debug' => array(
        'title'         => __( 'Debug log', 'adyen' ),
        'type'          => 'checkbox',
        'description'   => sprintf( __( 'Log Adyen events, such as server notifications requests, inside %s', 'adyen' ), '<code>' . WC_Log_Handler_File::get_log_file_path( 'adyen' ) . '</code>' ),
        'default'       => 'no' 
    ),
    'testing' => array(
        'title' 		=> __( 'Adyen Sandbox', 'adyen' ),
        'type' 			=> 'title',
        'description'	=> __( 'Disable Adyen sandbox mode if you want go live with your store.', 'adyen' ) 
    ),
    'testmode' => array(
        'title' 		=> __( 'Adyen sandbox', 'adyen' ),
        'type' 			=> 'checkbox',
        'label' 		=> __( 'Enable Adyen sandbox', 'adyen' ),
        'default' 		=> 'yes',
        'description' 	=> sprintf( __( 'Adyen sandbox can be used to test payments. Sing up for a <a href="%s" target="_blank">test account</a>.', 'adyen' ), 'https://www.adyen.com/signup' )
    ),
    'hmac_test_key' => array(
        'title'			=> __( 'HMAC Test Key', 'adyen' ),
        'type'			=> 'text',
        'label'			=> __( 'Set HMAC test key', 'adyen' ),
        'description'	=> __( 'Enter your Adyen generated HMAC key (Test Platform).', 'adyen' ),
        'desc_tip'      => true
    ),
);
